Loading...
Searching...
No Matches
Opm::CompositionFromFugacities< Scalar, FluidSystem, Evaluation > Class Template Reference

Calculates the chemical equilibrium from the component fugacities in a phase. More...

`#include <CompositionFromFugacities.hpp>`

## Public Types

typedef Dune::FieldVector< Evaluation, numComponents > | ComponentVector

## Static Public Member Functions

template<class FluidState>
static void | guessInitial (FluidState &fluidState, unsigned phaseIdx, const ComponentVector &)
| Guess an initial value for the composition of the phase.
template<class FluidState>
static void | solve (FluidState &fluidState, typename FluidSystem::template ParameterCache< typename FluidState::Scalar > &paramCache, unsigned phaseIdx, const ComponentVector &targetFug)
| Calculates the chemical equilibrium from the component fugacities in a phase.

## Static Protected Member Functions

template<class FluidState>
static void | solveIdealMix_ (FluidState &fluidState, typename FluidSystem::template ParameterCache< typename FluidState::Scalar > &paramCache, unsigned phaseIdx, const ComponentVector &fugacities)
template<class FluidState>
static Scalar | linearize_ (Dune::FieldMatrix< Evaluation, numComponents, numComponents > &J, Dune::FieldVector< Evaluation, numComponents > &defect, FluidState &fluidState, typename FluidSystem::template ParameterCache< typename FluidState::Scalar > &paramCache, unsigned phaseIdx, const ComponentVector &targetFug)
template<class FluidState>
static Scalar | update_ (FluidState &fluidState, typename FluidSystem::template ParameterCache< typename FluidState::Scalar > &paramCache, Dune::FieldVector< Evaluation, numComponents > &x, Dune::FieldVector< Evaluation, numComponents > &, unsigned phaseIdx, const Dune::FieldVector< Evaluation, numComponents > &targetFug)
template<class FluidState>
static Scalar | calculateDefect_ (const FluidState &params, unsigned phaseIdx, const ComponentVector &targetFug)

## Detailed Description

template<class Scalar, class FluidSystem, class Evaluation = Scalar>
class Opm::CompositionFromFugacities< Scalar, FluidSystem, Evaluation >

Calculates the chemical equilibrium from the component fugacities in a phase.

## Member Function Documentation

## solve()

template<class Scalar, class FluidSystem, class Evaluation = Scalar>
template<class FluidState>

void Opm::CompositionFromFugacities< Scalar, FluidSystem, Evaluation >::solve | ( | FluidState & | fluidState,
|  | typename FluidSystem::template ParameterCache< typename FluidState::Scalar > & | paramCache,
|  | unsigned | phaseIdx,
|  | const ComponentVector & | targetFug )

inline static

Calculates the chemical equilibrium from the component fugacities in a phase.

The phase's fugacities must already be set.

The documentation for this class was generated from the following file:

- opm/material/constraintsolvers/CompositionFromFugacities.hpp